JDBCDataSource (HSQLDB 2.4.0 API)
Date: 2017-04-09

org.hsqldb.jdbc

## Class JDBCDataSource

- java.lang.Object
- - org.hsqldb.jdbc.JDBCCommonDataSource
  - - org.hsqldb.jdbc.JDBCDataSource

- All Implemented Interfaces:
    Serializable, Wrapper, Referenceable, CommonDataSource, DataSource

      public class JDBCDataSource
      extends JDBCCommonDataSource
      implements DataSource, Serializable, Referenceable, Wrapper

  A factory for connections to the physical data source that this `DataSource` object represents. An alternative to the `DriverManager` facility, a `DataSource` object is the preferred means of getting a connection. An object that implements the `DataSource` interface will typically be registered with a naming service based on the Java™ Naming and Directory (JNDI) API.

  The `DataSource` interface is implemented by a driver vendor. There are three types of implementations:

  1. Basic implementation -- produces a standard `Connection` object
  2. Connection pooling implementation -- produces a `Connection` object that will automatically participate in connection pooling. This implementation works with a middle-tier connection pooling manager.
  3. Distributed transaction implementation -- produces a `Connection` object that may be used for distributed transactions and almost always participates in connection pooling. This implementation works with a middle-tier transaction manager and almost always with a connection pooling manager.

  A `DataSource` object has properties that can be modified when necessary. For example, if the data source is moved to a different server, the property for the server can be changed. The benefit is that because the data source's properties can be changed, any code accessing that data source does not need to be changed.

  A driver that is accessed via a `DataSource` object does not register itself with the `DriverManager`. Rather, a `DataSource` object is retrieved though a lookup operation and then used to create a `Connection` object. With a basic implementation, the connection obtained through a `DataSource` object is identical to a connection obtained through the `DriverManager` facility.

  ### HSQLDB-Specific Information:

  This implementation of data source is a basic implementation and does not perform connection pooling.

  The getter and setter methods of the parent class, `JDBCCommonDataSource`, can be used.

  Since:
    JDK 1.4, 1.7.2
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JDBCDataSource()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Connection` | `getConnection()` Retrieves a new connection using the properties that have already been set.
    `Connection` | `getConnection(String username, String password)` Retrieves a new connection using the given username and password, and the database url that has been set.
    `Reference` | `getReference()` Retrieves the Reference of this object.
    `boolean` | `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
    `<T> T` | `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

    - ### Methods inherited from class org.hsqldb.jdbc.JDBCCommonDataSource

      `getDatabase, getDatabaseName, getDataSourceName, getDescription, getLoginTimeout, getLogWriter, getNetworkProtocol, getParentLogger, getServerName, getUrl, getURL, getUser, setDatabase, setDatabaseName, setLoginTimeout, setLogWriter, setPassword, setProperties, setUrl, setURL, setUser`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.sql.CommonDataSource

      `getLoginTimeout, getLogWriter, getParentLogger, setLoginTimeout, setLogWriter`

- - ### Constructor Detail

    - #### JDBCDataSource

          public JDBCDataSource()

  - ### Method Detail

    - #### getConnection

          public Connection getConnection()
                                   throws SQLException

      Retrieves a new connection using the properties that have already been set.
      Specified by:
        `getConnection` in interface `DataSource`
      Returns:
        a connection to the data source
      Throws:
        `SQLException` - if a database access error occurs

    - #### getConnection

          public Connection getConnection(String username,
                                          String password)
                                   throws SQLException

      Retrieves a new connection using the given username and password, and the database url that has been set. No other properties are used for the connection
      Specified by:
        `getConnection` in interface `DataSource`
      Parameters:
        `username` - the database user on whose behalf the connection is being made
        `password` - the user's password
      Returns:
        a connection to the data source
      Throws:
        `SQLException` - if a database access error occurs

    - #### unwrap

          public <T> T unwrap(Class<T> iface)
                       throws SQLException

      Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.
      Specified by:
        `unwrap` in interface `Wrapper`
      Parameters:
        `iface` - A Class defining an interface that the result must implement.
      Returns:
        an object that implements the interface. May be a proxy for the actual implementing object.
      Throws:
        `SQLException` - If no object found that implements the interface
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### isWrapperFor

          public boolean isWrapperFor(Class<?> iface)
                               throws SQLException

      Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.
      Specified by:
        `isWrapperFor` in interface `Wrapper`
      Parameters:
        `iface` - a Class defining an interface.
      Returns:
        true if this implements the interface or directly or indirectly wraps an object that does.
      Throws:
        `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getReference

          public Reference getReference()
                                 throws NamingException

      Retrieves the Reference of this object.
      Specified by:
        `getReference` in interface `Referenceable`
      Returns:
        The non-null Reference of this object.
      Throws:
        `NamingException` - If a naming exception was encountered while retrieving the reference.

Copyright © 2001 - 2017 HSQL Development Group.